#include "flex.h"


int vtsetnull(); static int (*dummy)() = vtsetnull;
extern USERFUNCS acttest[];
USEREXITS userexits[] = { 
"acttest", acttest,
 0, 0 };

static int mainfunc();


USERFUNCS acttest[] = {
"mainfunc", mainfunc,
 0, 0 };

#line 5  "acttest.flx"

#define P_UNLOAD  0x0001   /* flag to unload data */
#define P_DELETE  0x0002   /* flag to delete data */
 
static FILE *fpunload;

static mainfunc(argc, argv)
int argc;
char *argv[];
{
    extern int sel_armcus();
    flexload(argv[1]); /* loads PIC file with Table definitions */

    move("2", &ghdhead.hdDfptr[0] );  /* So processing starts with customer = 2.
#line 19 "acttest.flx"
                                  Note that this is the index field used by 
                                  fmstart() below. 
                               */
    process(ghdhead.hdDhptr[0] , &ghdhead.hdDiptr[0] , sel_armcus, P_UNLOAD);
}

static int process(pdbhead, pdbindex, puserfunc, flag)
DBHEAD *pdbhead;
DBINDEX *pdbindex;
PFUNC puserfunc;
int flag;
{
    int mode;
    int cc;
    int i;

    /* Open file to unload table into */
    if (flag & P_UNLOAD) {
        if ( NULL == (fpunload = fopen("unload.log", "w")) ) {
             msggerr( "error opening unload file");
             return(-1);
             }
       }

    if ( 0 > fmopen(pdbhead, ISINOUT+ISMANULOCK) ) {
       fmerrmsg(pdbhead);
       return;
       }

    if (fmstart(pdbhead,  pdbindex, 0, ISGTEQ) < 0) {
        if ( iserrno != 111 && iserrno != 110) {
            fmerrmsg(pdbhead);
            return;
            }
        return;
        }

    mode = ISCURR;
    for (i = 0; ;++i) {
         if ( 0 >  fmread(pdbhead, mode) ) {
             if (iserrno != 110 && iserrno != 111) {
                fmerrmsg(pdbhead);
                break;
                }
             break;
             }
        mode = ISNEXT;

        if ( puserfunc != (PFUNC)0) {
           cc = (* puserfunc)();
           if (cc != 0)
               continue;
           }


        if (flag & P_UNLOAD) {
            printf( "Unloading record %d\r\n\r\n", i);
            cc = unload(pdbhead);
            if ( cc < 0) {
                fmerrmsg(pdbhead);
                break;          
                }
            continue;
            }

        if (flag & P_DELETE) {
            printf( "Deleting record %d\r\n\r\n", i);
            cc = fmdelcurr(pdbhead);
            if ( cc < 0) {
                fmerrmsg(pdbhead);
                break;          
                }
            continue;
            }

        }

    fmclose(pdbhead);

    /* Close unload file */
    if (flag & P_UNLOAD) {
       fclose(fpunload);
       }
}

static int unload(pdbhead)
DBHEAD *pdbhead;
{
    DBFIELD *pdbfield;
    char buffer[200];
    int dec;
    int i;

     pdbfield = pdbhead->dhDbfield;
     for (i=0; i < pdbhead->dhDfnum; ++i, ++pdbfield) {
         dec = 0;
         if (pdbfield->dfType == MONEYTYPE)
             dec = 2;
         if (pdbfield->dfType == DECTYPE)
             dec = 4;
         if (pdbfield->dfType == DOUBLETYPE)
             dec = 4;
         if (pdbfield->dfType == FLOATTYPE)
             dec = 4;
         dfbuftostr(getdfbuf(pdbfield), buffer, pdbfield->dfType, 
                 getvtlen(pdbfield->dfType, pdbfield->dfBytes), dec, 0);
         fprintf(fpunload, "%s|", strcompress(buffer));
         }
     fprintf(fpunload, "\n");

}

static int sel_armcus()
{
   long referencedate;

    /* This userexit function can be used to select records
       based on specific fields.   You will probably have one
       of these userexits for each table being processed by the 
       generic code above for.

           Return 1 to skip record
           Return 0 to process record
     */

    rstrdate( "01/01/93", &referencedate, 0);
    if ((getdflong( &ghdhead.hdDfptr[35]))>  referencedate)
       return(1);
    

    return(0);
}


